<?php

namespace Drupal\dsfr_paragraph\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\paragraphs\Entity\ParagraphsType;

class ParagraphController extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  public function state() {

    $available_paragraphs = [];
    $manage = \Drupal::service('dsfr_paragraph.paragraphManage');
    $storage = \Drupal::service('dsfr_paragraph.paragraphStorage');

    $components = $storage->typeParagraphs();
    $paragraphs_type = ParagraphsType::loadMultiple();
    
    foreach($components as $key => $label) {
      
      $dsfr_key = 'dsfr_' . $key;
      if(!array_key_exists($dsfr_key, $paragraphs_type)) { $manage->paraCreate($key, $label); }
      $available_paragraphs[$dsfr_key] = $label;
    }

    return array(
      '#theme' => 'settings',
      '#data' => $available_paragraphs
    );
  }
}

?>