<?php

namespace Drupal\dsfr_paragraph;

use Drupal\field\Entity\FieldConfig;
use Drupal\field\Entity\FieldStorageConfig;
use Drupal\paragraphs\Entity\ParagraphsType;

use Drupal\Core\Controller\ControllerBase;

class ParagraphManage extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  function paraCreate($id, $label) {

    $paragraph_type = ParagraphsType::create([
      'id' => 'dsfr_' . $id,
      'label' => $label,
    ]);
    $paragraph_type->save();
  } 

  /**
   * {@inheritdoc}
   */
  function paraFieldStorage( $id, $params ) {

    $field_storage = FieldStorageConfig::create([
      'field_name' => 'dsfr_p_' . $id,
      'entity_type' => 'paragraph',
      'type' => $params['type'],
    ]);
    $field_storage->save();

    return $field_storage;
  } 

  /**
   * {@inheritdoc}
   */
  function paraFieldCreate( $field_storage, $bundle, $label ) {

    $field = FieldConfig::create([
      'field_storage' => $field_storage,
      'bundle' => $bundle,
      'label' => $label,
    ]);
    $field->save();
  }
}