<?php

namespace Drupal\dsfr_paragraph;

use Drupal\Core\Controller\ControllerBase;

class ParagraphStorage extends ControllerBase
{

  /**
   * {@inheritdoc}
   * Use for ready-to-use paragraphs for nodes
   */
  public function typeOperatingParagraphs()
  {
    return $pr = [

      /*'alert' => [

        'label' => $this->t('Alert'),
        'desc' => $this->t("Alerts can be used to draw the user's attention to a piece of information without interrupting the task in hand."),
        'fields' => [
          'margin_top',
          'alert',
          //'compact',
          'title',
          'message',
          'close',
          'margin_bottom'
        ]
      ],
      'callout' => [

        'label' => $this->t('Callout'),
        'desc' => $this->t("Highlighting allows the user to quickly distinguish information that complements the content consulted."),
        'fields' => [
          'margin_top',
          'color',
          'title',
          'message',
          //'action',
          'margin_bottom'
        ]
      ],*/
      'ckeditor' => [

        'label' => $this->t('Text'),
        //'desc' => $this->t("."),
        'fields' => [
          //'margin_top',
          //'color',
          //'font_size',
          'ckeditor5',
          //'margin_bottom'
        ]
      ],
      'highlight' => [

        'label' => $this->t('Highlight'),
        'desc' => $this->t("Highlighting allows the user to distinguish and locate information easily."),
        'fields' => [
          //'margin_top',
          //'color',
          //'font_size',
          'message',
          //'margin_bottom'
        ]
      ],
      /*'link' => [

        'label' => $this->t('Link'),
        'desc' => $this->t("The link allows navigation between a page and another content within the same page, the same site or external. The link must be explicit."),
        'fields' => [
          'margin_top',
          //'position',
          'action',
          'margin_bottom'
        ]
      ],*/
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function typeParagraphs()
  {
    $components = $this->dsfr_components();
    $other = $this->other_components();
    $comp = array_merge( $components, $other );
    ksort($comp);
    return $comp;
  }

  /**
   * {@inheritdoc}
   */
  public function dsfr_components() {

    return [

      'accordion' => t('Accordion'),
      'accordions' => t('Accordions'),
      'alert' => t('Alert'),
      'badge' => t('Badge'),
      'callout' => t('Callout'),
      'card' => t('Card'),
      'file_download' => t('File download'),
      'highlight' => t('Highlight'),
      'link' => t('Link'),
      'quote' => t('Quote'),
      'share' => t('Share'),
      'summary' => t('Summary'),
      'tab' => t('Tab'),
      'tabs' => t('Tabs'),
      'tag' => t('Tag'),
      'tile' => t('Tile')
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function other_components() {

    return [

      'block_custom' => t('Block custom'),
      'ckeditor' => t('Text editor'),
      'files_table' => t('Files table'),
      'image' => t('Image'),
      'layout' => t('Layout')
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function fields() {

    return [

      //'alert' => t('Alert type'),
      'ckeditor5' => t('Text'),
      //'color' => t('Color'),
      //'compact' => t('Compact'),
      'image' => t('Image'),
      'link' => t('Link'),
      'long_text' => t('Text'),
      //'margin_bottom' => t('Bottom margin'),
      //'margin_top' => t('Top margin'),
      //'media_image',
      'message' => t('Text'),
      'title' => t('Title'),
    ];
  }
}